﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Telerik.Windows;
using System.Data.SqlClient;
using System.Data;
using System.IO;

namespace UploadSaveIntoDataBaseExample.Web
{
	/// <summary>
	/// Summary description for SampleUploadHandler
	/// </summary>
	/// 
	public class SampleUploadHandler : RadUploadHandler
	{
		int FileID = 0;
		public override bool SaveChunkData(string filePath, long position, byte[] buffer, int contentLength, out int savedBytes)
		{
			bool result = base.SaveChunkData(filePath, position, buffer, contentLength, out savedBytes);

			if (this.IsFinalFileRequest())
			{
				string UserID = this.GetQueryParameter("UserID");

				string connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["FilesDataBaseConnectionString"].ConnectionString;

				byte[] array = File.ReadAllBytes(filePath);

				using (SqlConnection conn = new SqlConnection(connectionString))
				{
					string cmdText = "INSERT INTO FileData(FileData, FileName, UserID) VALUES(@FileData, @FileName, @UserID)  SET @Identity = SCOPE_IDENTITY()";
					SqlCommand cmd = new SqlCommand(cmdText, conn);

					SqlParameter identityParam = new SqlParameter("@Identity", SqlDbType.Int, 0, "FileID");
					identityParam.Direction = ParameterDirection.Output;

					cmd.Parameters.AddWithValue("FileData", array);
					cmd.Parameters.AddWithValue("FileName", this.GetFileName());
					cmd.Parameters.AddWithValue("UserID", UserID);

					cmd.Parameters.Add(identityParam);

					conn.Open();
					cmd.ExecuteNonQuery();

					FileID = (int)identityParam.Value;

				}
			}

			return result;
		}

		public override Dictionary<string, object> GetAssociatedData()
		{
			Dictionary<string, object> associatedData = base.GetAssociatedData();
			if (this.IsFinalFileRequest())
			{
				associatedData.Add("FileID", FileID.ToString());
			}
			return associatedData;
		}


	}
}